unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TMainForm = class(TForm)
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

function GetChannelName(const line: string): string;
var
  i: integer;
  s: string;
  start: boolean;
begin
  result := '';
  start := false;
  for i := 1 to Length(line) do
  begin
    s := copy(line, i, 1);
    if (s = '"') and start then
    begin
      break;
      start := false;
    end;
    if start then result := result + s;
    if (s = '"') and not start then
    begin
      start := true;
    end;
  end;
end;

function GetChannelData(const line: string): string;
var
  i: integer;
  s: string;

  // 0 = vor dem ersten "
  // 1 = nach dem ersten "
  // 2 = nach dem zweiten ", leerzeichen
  // 3 = das erste nicht leerzeichen: START
  state: integer;
begin
  result := '';
  state := 0;
  for i := 1 to Length(line) do
  begin
    s := copy(line, i, 1);

    if (state = 0) then
    begin
      if s = '"' then state := 1;
    end
    else if (state = 1) then
    begin
      if s = '"' then state := 2;
    end
    else if (state = 2) then
    begin
      if s <> ' ' then state := 3;
    end;

    if (state = 3) then
    begin
      result := result + s;
    end;
  end;
end;

procedure DoSplice(const fn: string; var Oini, Ovid, Orad: TStrings);
var
  x: tstrings;
  i: integer;
  first: string;
begin
  x := TStringList.Create;
  try
    x.LoadFromFile(fn);
    for i := 0 to x.Count - 1 do
    begin
      first := copy(x.Strings[i], 1, 1);
      if first = 'r' then
        Orad.Add(x.Strings[i])
      else if first = 'v' then
        Ovid.Add(x.Strings[i])
      else
        Oini.Add(x.Strings[i]);
    end;
  finally
    x.Free;
  end;
end;

procedure Sorting(var st1, st2, st3: tstrings);
var
  i, j: integer;
  found: boolean;
  toadd, chn, chd, name_ch_a, name_ch_b: string;
  st2_namen, st2_data: tstrings;
resourcestring
  LNG_GAP = '# GAP at Channel %d! The channel name was "%s"';
  LNG_NEW_ENTRIES = '# STARTING NEW OR MOVED CHANNELS';
  LNG_NAME_CHANGE = '# INFO: "%s" changed name to "%s".';
begin
  st2_namen := TStringList.Create;
  st2_data := TStringList.Create;
  try
    for i := 0 to st2.Count - 1 do
    begin
      // Die Namen aller Kanle herausfiltern, um spter zu vergleichen
      st2_namen.Add(GetChannelName(st2.Strings[i]));

      // Die Empfangsdaten aller Kanle herausfiltern, um spter zu vergleichen
      // (Wichtig bei Namenswechslern)
      st2_data.Add(GetChannelData(st2.Strings[i]));
    end;

    for i := 0 to st1.Count - 1 do
    begin
      found := false;
      chn := GetChannelName(st1.Strings[i]);
      toadd := '';
      for j := 0 to st2.Count - 1 do
      begin
        if LowerCase(chn) = LowerCase(st2_namen.Strings[j]) then
        begin
          found := true;
          toadd := st2.Strings[j];
          st2.Delete(j);
          st2_namen.Delete(j);
          st2_data.Delete(j);
          break;
        end;
      end;

      if found then
      begin
        { Den Eintrag mit dem gleichen Namen (kann andere Transponderdaten enthalten) hinzufgen! }
        st3.Add(toadd);
      end
      else
      begin
        // Nichts gefunden... hat ein anderer Kanal vielleicht die selben Empfangsdaten?
        // Dann wre es nmlich nur ein Namenswechser, bei dem kein GAP notwendig ist.

        chd := GetChannelData(st1.Strings[i]);
        toadd := '';
        for j := 0 to st2.Count - 1 do
        begin
          if chd = st2_data.Strings[j] then
          begin
            found := true;
            toadd := st2.Strings[j];

            name_ch_a := chn;
            name_ch_b := st2_namen.Strings[j];

            st2.Delete(j);
            st2_namen.Delete(j);
            st2_data.Delete(j);
            break;
          end;
        end;

        if found then
        begin
          { War ein Namenswechsler mit gleichen Transponderdaten }
          st3.Add(Format(LNG_NAME_CHANGE, [name_ch_a, name_ch_b]));
          st3.Add(toadd);
        end
        else
        begin
          // Immer noch nichts gefunden...

          st3.Add(Format(LNG_GAP, [i+1, chn]));
        end;
      end;
    end;

    { Den Rest anfgen }
    st3.Add('');
    st3.Add(LNG_NEW_ENTRIES);
    st3.Add('');
    for j := 0 to st2.Count - 1 do
    begin
      st3.Add(st2.Strings[j]);
    end;
  finally
    st2_namen.Free;
    st2_data.Free;
  end;
end;

procedure DoWork(a, b, c: string);
var
  st1_ini, st1_vid, st1_rad: tstrings;
  st2_ini, st2_vid, st2_rad: tstrings;
  st3: tstrings;
  j: integer;
resourcestring
  LNG_GENERATED_BY = '# Generated by TV Sort by Daniel Marschall';
  LNG_VIDEO = '# --- VIDEO ---';
  LNG_RADIO = '# --- RADIO ---';
begin
  st1_ini := TStringList.Create; { Nicht verwendet }
  st1_vid := TStringList.Create;
  st1_rad := TStringList.Create;
  st2_ini := TStringList.Create;
  st2_vid := TStringList.Create;
  st2_rad := TStringList.Create;
  DoSplice(a, st1_ini, st1_vid, st1_rad);
  DoSplice(b, st2_ini, st2_vid, st2_rad);
  st3 := TStringList.Create;
  try
    st3.Add(LNG_GENERATED_BY);
    st3.Add('');

    { Wir nehmen die Transponderlisten von der neu geladenen, neueren Datei }
    { Sie msste eigentlich der originalen Liste entsprechen }

    // Aber vorher noch ein paar Schnheitskorrekturen durchfhren
    st2_ini.Text := StringReplace(st2_ini.Text, '# (s)     "ccccccccc"     xxxxx     xxxxx     u/n       xxx.x     e/w         y/n                           #',
                                                '# (s)     "ccccccccc"     xxxxx     xxxxx     u/n       xxx.x     e/w         y/n                             #', [rfReplaceAll]);
    st2_ini.Text := StringReplace(st2_ini.Text, '# s       "ASTRA DEF"     9750      10600     universal 19.2      east         y                            #',
                                                '# s       "ASTRA DEF"     9750      10600     universal 19.2      east        y                               #', [rfReplaceAll]);

    for j := 0 to st2_ini.Count - 1 do
    begin
      st3.Add(st2_ini.Strings[j]);
    end;

    { Nun die sortierten Videokanle anfgen }
    st3.Add('');
    st3.Add(LNG_VIDEO);
    st3.Add('');
    Sorting(st1_vid, st2_vid, st3);

    { Nun die sortierten Radiokanle anfgen }
    st3.Add('');
    st3.Add(LNG_RADIO);
    st3.Add('');
    Sorting(st1_rad, st2_rad, st3);

    st3.SaveToFile(c);
  finally
    st3.free;
    st1_ini.free;
    st1_vid.free;
    st1_rad.free;
    st2_ini.free;
    st2_vid.free;
    st2_rad.free;
  end;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var
  a, b, c: string;
resourcestring
  LNG_CHOOSE_ORIGINAL = 'Please choose the original TV channels file';
  LNG_CHOOSE_UNSORTED = 'Please choose the new TV channels file (unsorted)';
  LNG_CHOOSE_SORTED = 'Where should the new channel list with the old sorting order be saved?';
  LNG_FINISHED = 'Finished!';
begin
  Timer1.Enabled := false;

  MessageDlg(LNG_CHOOSE_ORIGINAL, mtInformation, [mbOK], 0);
  if OpenDialog1.Execute then
  begin
    a := OpenDialog1.FileName;

    MessageDlg(LNG_CHOOSE_UNSORTED, mtInformation, [mbOK], 0);
    if OpenDialog1.Execute then
    begin
      b := OpenDialog1.FileName;

      MessageDlg(LNG_CHOOSE_SORTED, mtInformation, [mbOK], 0);
      if SaveDialog1.Execute then
      begin
        c := SaveDialog1.FileName;

        DoWork(a, b, c);

        MessageDlg(LNG_FINISHED, mtInformation, [mbOK], 0);
      end;
    end;
  end;

  Close;
end;

end.
